from decimal import Decimal
import unittest

from pyson.ObjectMapper import ObjectMapper

from geniusweb.issuevalue.NumberValue import NumberValue
from geniusweb.issuevalue.NumberValueSet import NumberValueSet
from geniusweb.issuevalue.ValueSet import ValueSet
from immutablelist.Range import Range


class NumberValueSetTest(unittest.TestCase):
    pyson=ObjectMapper()
    val = NumberValueSet(Range(Decimal('12.2'), Decimal('12.6'), Decimal('0.3')))
    valjson = {"range":{"low":12.2,"high":12.6,"step":0.3}}

    def testSerialize(self):
        print(str(self.pyson.toJson(self.val)))
        self.assertEqual(self.valjson, self.pyson.toJson(self.val))
        
    def testDeserialize(self):
        set:NumberValueSet= self.pyson.parse(self.valjson, ValueSet)
        self.assertEqual(self.val, set)
        self.assertTrue(isinstance(set.getRange().getLow(), Decimal))
        
    def testIterator(self):
        self.assertTrue(NumberValue(Decimal('12.2')) in self.val)
        
    def testGetter(self):
        set=NumberValueSet(Range(Decimal("900"),Decimal("1800"), Decimal("300")))
        print (str(set.get(1)))
        